import java.io.* ;
/*
 AJGrep

 Luc Maranget, projet Moscova, Inria Rocquencourt
 
 Copyright 2006 Institut National de Recherche en Informatique et    
 en Automatique.  All rights reserved.  This file is distributed     
 under the terms of the Q Public License version 1.0.          
*/

class AJgrep {

  private static boolean someNonNull(Object[] t) {
    for (int i=0 ; i < t.length ; i++)
      if (t[i] != null) return true ;
    return false ;
  }

  private static Table zyva(Auto a, int nerrs, States ex) {
    if (a.someEpsilon()) {
      a.sharpOut() ;
      //      System.err.println(a) ;
      return new Table3(a, nerrs, ex) ;
    } else if (a.someSharp()) {
      return new Table2(a, nerrs, ex) ;
    } else {
      return new Table1(a, nerrs, ex) ;
    }
  }

  private static void usage() {
    System.err.println("Usage: java AJgrep n pat [filename]") ;
    System.exit(2) ;
  }

  public static void main(String [] argv) {
    if (argv.length < 2) { usage() ; }
    int nerrs = Integer.parseInt(argv[0]) ;
    String pat = argv[1];
    Auto a = new Auto(pat) ;
    States ex = States.setCard(a.fstate+1) ;
    Table t = zyva(a, nerrs, ex) ;
    Fichier f ;
    if (argv.length < 3)
      f = new Fichier(new BufferedReader (new InputStreamReader(System.in))) ;
    else
      f = new Fichier(argv[2]) ;
    t.match(f, nerrs) ;
    f.close() ;
  }
}
