import java.io.* ;
/*
 AJGrep

 Luc Maranget, projet Moscova, Inria Rocquencourt
 
 Copyright 2006 Institut National de Recherche en Informatique et    
 en Automatique.  All rights reserved.  This file is distributed     
 under the terms of the Q Public License version 1.0.          
*/

class Fichier {
  private BufferedReader in ;

  Fichier (String name) {
    try {
      in = new BufferedReader(new FileReader (name)) ;
    } catch (IOException e) {
      System.err.println("Cannot open " + name + " " + e.getMessage()) ;
      System.exit(2) ;
    }
  }

  Fichier (BufferedReader in) {
    this.in = in ;
  }
  String nextLine () {
    String r = null;

    try {
      r = in.readLine() ;
    } catch (IOException e) {
      System.err.println(e.getMessage()) ;
      System.exit(2) ;
    }
    return r ;
  }

  void close () {
    try {
      in.close() ;
    } catch (IOException e) {
      System.err.println(e.getMessage()) ;
      System.exit(2) ;
    }
  }

  public static void main (String[] argv) {
    Fichier in = new Fichier(argv[0]) ;
    String line ;
    while ((line = in.nextLine()) != null) {
      System.out.println(line) ;
    }
    in.close() ;
  }
}
